/**
 * 
 */
package app;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;

import javax.swing.JComboBox;
import javax.swing.JTextArea;

import de.congrace.exp4j.UnknownFunctionException;
import de.congrace.exp4j.UnparsableExpressionException;

/**
 * @author Petar
 *
 */
public interface Algoritam {
	
	/**
	 * Vraća listu postavki koju GUI može vizualizirati
	 * @return listu postavki
	 */
	public ArrayList<Postavka<?>> dajPostavke();
	
	/**
	 * Interno sprema postavke odabrane putem GUI-a
	 * @throws InterruptedException 
	 * @throws InvocationTargetException 
	 * @throws Exception 
	 */
	public void spremiPostavke(ArrayList<String> vrijednosti) throws InvocationTargetException, InterruptedException;
	
	/**
	 * Pokreće algoritam
	 * @param p Prikaz algoritma
	 * @param cp 
	 * @param pause_button 
	 * @throws InterruptedException 
	 * @throws InvocationTargetException 
	 */
	public void kreni(Prikaz p, JTextArea ispis, JComboBox<String> delay, State status) throws InvocationTargetException, InterruptedException;
	
	/**
	 * Postavlja funkciju koju optimira
	 * @param tekst izraz/funkcija
	 * @throws UnknownFunctionException
	 * @throws UnparsableExpressionException
	 * @throws Exception 
	 */
	public void postaviFunkciju(String tekst) throws UnknownFunctionException, UnparsableExpressionException;
	
	
	/**
	 * Vraća ime algoritma
	 * @return ime algoritma
	 */
	public String getName();
	
}
